# Suunnitelman tallennus

* Ominaisuuden vastuuhenkilö: Jesse Heikkinen
* Hyväsksytty

### Kuvaus

Kun opiskelija tai työelämän yhteyshenkilö on valinnut kurssit heillä on
mahdollisuus tallentaa heidän suunnitelmansa. Tallentaminen tapahtuu sille
tarkoitetulla napilla palvelussa.


### Käyttötapaukset (Use Cases)

Täitä käyttötapauksia voidaan tarvittaessa käyttää hyväksyntätesteinä tai pohjana niille.

* [Use Case 1](FT1-kayttotapaus.md)
* [Use Case 2](FT2-kayttotapaus.md)


### Alustavat käyttäjätarinat (User Storys)

Opiskelija Olli on tekemässä kurssi valintojaan ja haluaa tallentaa
suunnitelmansa, jotta hän voi vielä myöhemmin muokata tai tarkastella sitä.
Olli painaa tallenna nappia ja suunnitelma on nyt tallennettu.

### Käyttöliittymänäkymä/mock

![](https://openclipart.org/image/300px/svg_to_png/178764/1370010418.png&disposition=attachment)


### Ominaisuuteen liittyvät toiminnalliset vaatimukset

* Palvelussa on nappi suunnitelman tallennusta varten


### Ominaisuuteen liittävät ei-toiminnalliset vaatimukset


### Ominaisuuteen liittyvät rajaukset

* Tervehdysviestin muodon on noudatettava standardia ZZZ123.1


### Testauksessa huomioitavaa:

| Testi  | Testin lähde  | Kuka vastaa  |
|:-: | :-:|:-:|
| [Testitapaus 1]( FT1-testitapaus1.md)  | Use Case 1  |  |
| [Testitapaus 2]( FT1-testitapaus2.md)  |  |  |
| [Testitapaus 3]( FT1-testitapaus3.md)  | Use Case 2 |  |
| [Testitapaus 4]( FT1-testitapaus4.md)  | Vaatimus REQ001 |  |
| [Testitapaus 5]( FT1-testitapaus5.md)  |  |  |
| [Testitapaus 6]( FT1-testitapaus6.md)  |  |  |


### Status/Aikataulu/Roadmap

| Status | |
|:----:|:----:|
| Hyväksytty/ Hylätty | - |




